local M = {}
local threshold_a = {50.0,50,50.0,50.0,50.0,50.0,50.0}
--threshold_a = {1.0,50,1.05,0.5,0.4,0.35,0.35}
minthrottle = 0.1
local epsilon = 0.1
t = 0
trigger = false

local function onReset()
	electrics.values['v_old'] = 0
	electrics.values['maxthrottle'] = 1
	math.randomseed(os.time())
end

local function rpmDep(rpm)
	return math.pow(3200/(1 + rpm), 0.3)
end

local function clutchDep(cl)
	return math.pow(1-cl,3)
end

local function step(x)
	if (x > 0) then
		return 1
	else
		return 0
	end
end

local function adjustThrottle(t, dt)
	--electrics.values['throttle'] = electrics.values['throttle']*(1-math.exp(-1500/(1+electrics.values['rpm']))*math.exp(-(t-2*dt)*(t-2*dt))/(dt*dt))
	if (electrics.values['rpm'] > 2000) then
		--electrics.values['throttle'] = electrics.values['throttle']*(1-math.pow((electrics.values['rpm']-2000)/3200,5)*math.exp(-(t-2*dt)*(t-2*dt))/(dt*dt))
	end
	--print(math.pow(electrics.values['rpm']/5200,5))
end

local function updateGFX(dt)
	local omegaRL = -wheels.wheels[0].angularVelocity
	local omegaRR = wheels.wheels[2].angularVelocity
	local radius = (wheels.wheels[0].radius+wheels.wheels[2].radius)/2
	local velocity = omegaRR*radius
	local vnow = electrics.values['wheelspeed']
	local a = (vnow-electrics.values['v_old'])/dt
	local cl = electrics.values['clutch']
	local gear = drivetrain.gear
	if gear ~= 0 then
		gr = 1
	else
		gr = 0
	end
	if a > threshold_a[gear+2]*3200/(1 + electrics.values['rpm']) then
		electrics.values['maxthrottle'] = math.max(minthrottle, electrics.values['maxthrottle']/(1 + dt*clutchDep(cl)*(a-threshold_a[gear+2]*rpmDep(electrics.values['rpm']))))
	elseif a <= threshold_a[gear+2]*3200/(1 + electrics.values['rpm']) then
		electrics.values['maxthrottle'] = math.max(minthrottle, math.min(1, (1 + dt*clutchDep(cl)*(threshold_a[gear+2]*rpmDep(electrics.values['rpm'])-a))*electrics.values['maxthrottle']))
	end
	if (math.random() > 1 - 2*step((electrics.values['rpm']-2000))*math.pow((electrics.values['rpm']-2000)/3200,1)*dt) then
		trigger = true
	end
	if (trigger == true) then
		adjustThrottle(t, dt)
		t = t + dt
		if (t > 4*dt) then
			t = 0
			trigger = false
		end
	end
	if (electrics.values['throttle'] > electrics.values['maxthrottle'] and gr > 0) then
		electrics.values['throttle'] = cl*electrics.values['throttle'] + clutchDep(cl)*electrics.values['maxthrottle']
	end
	electrics.values['v_old'] = vnow
	if drivetrain.torque > 10 then
		drivetrain.torque = 10
	end
	--print(electrics.values['throttle'])
	--print(electrics.values['maxthrottle'])
end

M.onInit    = onReset
M.onReset   = onReset
M.updateGFX = updateGFX

return M